"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getContainerSize = getContainerSize;
exports.isTileGroup = isTileGroup;
exports.tileVectorParser = void 0;

var _l7Utils = require("@antv/l7-utils");

var tileVectorParser = ['mvt', 'geojsonvt', 'testTile'];
/**
 * 判断当前图层是否是瓦片图层
 * @param layer
 * @returns
 */

exports.tileVectorParser = tileVectorParser;

function isTileGroup(layer) {
  var source = layer.getSource();
  return tileVectorParser.includes(source.parser.type);
}

function getContainerSize(container) {
  if (container.getContext) {
    return {
      width: container.width / _l7Utils.DOM.DPR,
      height: container.height / _l7Utils.DOM.DPR
    };
  } else {
    return container.getBoundingClientRect();
  }
}